#include <ch32fun.h>
#include <rand.h>
#include <rsa.h>
#include <stdint.h>
#include <stdio.h>

#define LED_PIN PD6

void exit_blink() {
    for (int i = 0; i < 4; i++) {
        funDigitalWrite(LED_PIN, FUN_HIGH);
        Delay_Ms(50);
        funDigitalWrite(LED_PIN, FUN_LOW);
        Delay_Ms(50);
    }
}

void enter_blink() {
    for (int i = 0; i < 2; i++) {
        funDigitalWrite(LED_PIN, FUN_HIGH);
        Delay_Ms(200);
        funDigitalWrite(LED_PIN, FUN_LOW);
        Delay_Ms(200);
    }
}

int main() {
    SystemInit();

    printf("Entering...");

    funGpioInitAll();
    funPinMode(LED_PIN, GPIO_Speed_10MHz | GPIO_CNF_OUT_PP);

    enter_blink();

    uint64_t p = gen_prime(1 << 15, 1 << 16);
    uint64_t q = gen_prime(1 << 15, 1 << 16);

    while (p == q) p = gen_prime(1 << 15, 1 << 16);

    uint64_t n = p * q;

    // Make these work by patching printf
    printf("P: %llu\n", p);
    printf("Q: %llu\n", q);
    printf("N: %llu\n", n);

    for (int idx = 0; idx < 16; idx++) {
        funDigitalWrite(LED_PIN, p >> idx & 1);
        Delay_Ms(200);
    }
    for (int idx = 0; idx < 16; idx++) {
        funDigitalWrite(LED_PIN, q >> idx & 1);
        Delay_Ms(200);
    }
    for (int idx = 0; idx < 16; idx++) {
        funDigitalWrite(LED_PIN, n >> idx & 1);
        Delay_Ms(200);
    }

    // Exit and hang forever
    exit_blink();
    while (1);
}
